/*
 *  OpFlowTools_StructFun.cpp
 *  
 *
 *  Created by Pierre Dérian on 07/05/10.
 *  Copyright 2010 INRIA. All rights reserved.
 *
 */

#include <iostream>
#include "OpFlowTools_structFun.h"

using namespace cimg_library;
using namespace std;

/*=======================STRUCTURE FUNCTIONS=from=Mr Heas===========================*/

double  power_LeastSquareEstimator(const CImg<double> &S2,const CImg<double> &S2_, int neta, int lo){
	
	double nom,den;
	double tmp1,tmp2,tmp3,tmp4;
	tmp1=0;tmp4=0;tmp3=0;tmp2=0;
	double tmp1_,tmp2_,tmp3_,tmp4_;
	tmp1_=0;tmp4_=0;tmp3_=0;tmp2_=0;
	double N=(lo-neta+1)+((int)(lo/sqrt(2))+1)-(max((int)(neta/sqrt(2)),1))+1;
	
	for (int l=neta; l<=lo;l++){
		tmp1+=log((double)l)*log((double)l);
		tmp2+=log((double)l)*log(S2(l));
		tmp3+=log((double)l);
		tmp4+=log(S2(l));
		if(S2(l)<=0){cout<<"Error : S2(l) does not belong to R+ "<<endl;}
	}
	double k;
	for (int l=max((int)(neta/sqrt(2)),1); l<=(int)(lo/sqrt(2))+1;l++){
		k=sqrt(2)*l;
		tmp1_+=log((double)k)*log((double)k);
		tmp2_+=log((double)k)*log(S2_(l));
		tmp3_+=log((double)k);
		tmp4_+=log(S2_(l));
		if(S2_(l)<=0){cout<<"Error : S2_cross(l) does not belong to R+ "<<endl;}
	}
	nom=N*(tmp2+tmp2_)-(tmp4+tmp4_)*(tmp3+tmp3_);
	den=N*(tmp1+tmp1_)-(tmp3+tmp3_)*(tmp3+tmp3_);
	return  nom/den;
};

CImg<double> StructureFunctionPthAbs_horiVertDir(const CImg<double> &UV, int neta, int lo,const CImgList <double> &z_right, const CImgList <double> &z_down,const CImgList <double> &z_t_right, const CImgList <double> &z_t_down, double  p){
	CImg<double> SP(lo+1);
	int nc=UV.width();
	int nl=UV.height();
	if (lo > (nc/2.) ||lo > (nl/2.)){
		cout<<"Error : lo must respect lo <= nc/2 and lo <= nl/2"<<endl;
	}
	SP.fill(0.);
	for (int l=neta;l<=lo;l++){
	  for (int i=0;i<nl;i++){
	    for (int j=0;j<nc;j++){
	      if(j>=l && j<(nc-l)){
          SP(l)+=(pow(abs((UV(j,i,0)-UV(j+l,i,0))),(double)p)*z_right[l-neta](j,i)
                  +pow(abs((UV(j,i,0)-UV(j-l,i,0))),(double)p)*z_right[l-neta](j-l,i));
          SP(l)+=(pow(abs((UV(j,i,1)-UV(j+l,i,1))),(double)p)*z_t_right[l-neta](j,i)
                  +pow(abs((UV(j,i,1)-UV(j-l,i,1))),(double)p)*z_t_right[l-neta](j-l,i));
	      }
	      if(i>=l && i<(nl-l)){
          SP(l)+=(pow(abs((UV(j,i,1)-UV(j,i+l,1))),(double)p)*z_down[l-neta](j,i)
                  +pow(abs((UV(j,i,1)-UV(j,i-l,1))),(double)p)*z_down[l-neta](j,i-l));
          SP(l)+=(pow(abs((UV(j,i,0)-UV(j,i+l,0))),(double)p)*z_t_down[l-neta](j,i)
                  +pow(abs((UV(j,i,0)-UV(j,i-l,0))),(double)p)*z_t_down[l-neta](j,i-l));
	      }
	    }
	  }
	  SP(l)/=2*((nl-2*l)*nc+(nc-2*l)*nl);
	  if (z_t_down[l-neta].sum()!=0){SP(l)/=2.;}
	  //cout<<" "<<SP(l)<<endl;
	}
	return SP;
};

CImg<double> StructureFunctionPthTransAbs_horiVertDir(const CImg<double> &UV, int neta, int lo,double p){
  CImgList <double> z_tmp(lo-neta+1,UV.width(),UV.height());for (int k=0;k<=lo-neta;k++){z_tmp[k].fill(0.);}
  CImgList <double> z_t_tmp(lo-neta+1,UV.width(),UV.height());for (int k=0;k<=lo-neta;k++){z_t_tmp[k].fill(1.);}
  return StructureFunctionPthAbs_horiVertDir(UV,neta,lo,z_tmp,z_tmp,z_t_tmp,z_t_tmp,p);
};

CImg<double> StructureFunctionPthLongAbs_horiVertDir(const CImg<double> &UV, int neta, int lo,double p){
  CImgList <double> z_tmp(lo-neta+1,UV.width(),UV.height());for (int k=0;k<=lo-neta;k++){z_tmp[k].fill(1.);}
  CImgList <double> z_t_tmp(lo-neta+1,UV.width(),UV.height());for (int k=0;k<=lo-neta;k++){z_t_tmp[k].fill(0.);}
  return StructureFunctionPthAbs_horiVertDir(UV,neta,lo,z_tmp,z_tmp,z_t_tmp,z_t_tmp,p);
};

CImg<double> StructureFunctionPthAbs_crossDir(const CImg<double> &UV, int neta, int lo,const CImgList <double> &z_rightDown, const CImgList <double> &z_rightUp,const CImgList <double> &z_t_rightDown, const CImgList <double> &z_t_rightUp, double p){	
	CImg<double> S2(lo+1);
	int nc=UV.width();
	int nl=UV.height();
	if (lo > (nc/2.) ||lo > (nl/2.)){
		cout<<"Error : lo must respect lo <= nc/2 and lo <= nl/2"<<endl;
	}
	S2.fill(0.);
	for (int l=max((int)(neta/sqrt(2)),1);l<=(int)(lo/sqrt(2))+1;l++){
	  for (int i=0;i<nl;i++){
	    for (int j=0;j<nc;j++){
	      if(j>=l && j<(nc-l)&&i>=l && i<(nl-l)){
          S2(l)+=pow(abs(((UV(j,i,0)-UV(j+l,i+l,0))+(UV(j,i,1)-UV(j+l,i+l,1)))/sqrt(2.)),(double)p)*z_rightDown[l-neta](j,i);
          S2(l)+=pow(abs(((UV(j,i,0)-UV(j-l,i-l,0))+(UV(j,i,1)-UV(j-l,i-l,1)))/sqrt(2.)),(double)p)*z_rightDown[l-neta](j-l,i-l);
          S2(l)+=pow(abs(((UV(j,i,0)-UV(j-l,i+l,0))-(UV(j,i,1)-UV(j-l,i+l,1)))/sqrt(2.)),(double)p)*z_rightUp[l-neta](j-l,i+l);
          S2(l)+=pow(abs(((UV(j,i,0)-UV(j+l,i-l,0))-(UV(j,i,1)-UV(j+l,i-l,1)))/sqrt(2.)),(double)p)*z_rightUp[l-neta](j,i);
          S2(l)+=pow(abs(((UV(j,i,0)-UV(j+l,i+l,0))-(UV(j,i,1)-UV(j+l,i+l,1)))/sqrt(2.)),(double)p)*z_t_rightDown[l-neta](j,i);
          S2(l)+=pow(abs(((UV(j,i,0)-UV(j-l,i-l,0))-(UV(j,i,1)-UV(j-l,i-l,1)))/sqrt(2.)),(double)p)*z_t_rightDown[l-neta](j-l,i-l);
          S2(l)+=pow(abs(((UV(j,i,0)-UV(j-l,i+l,0))+(UV(j,i,1)-UV(j-l,i+l,1)))/sqrt(2.)),(double)p)*z_t_rightUp[l-neta](j-l,i+l);
          S2(l)+=pow(abs(((UV(j,i,0)-UV(j+l,i-l,0))+(UV(j,i,1)-UV(j+l,i-l,1)))/sqrt(2.)),(double)p)*z_t_rightUp[l-neta](j,i);
	      }
	    }
	  }
	  S2(l)/=4*(nl-2*l)*(nc-2*l);
	  if (z_t_rightDown[l-neta].sum()!=0){S2(l)/=2.;}
    //cout<<" > "<<S2(l)<<endl;
	}
	return S2;
};

CImg<double> StructureFunctionPthTransAbs_crossDir(const CImg<double> &UV, int neta, int lo,double p){
  CImgList <double> z_tmp(lo-neta+1,UV.width(),UV.height());for (int k=0;k<=lo-neta;k++){z_tmp[k].fill(0.);}
  CImgList <double> z_t_tmp(lo-neta+1,UV.width(),UV.height());for (int k=0;k<=lo-neta;k++){z_t_tmp[k].fill(1.);}
  return StructureFunctionPthAbs_crossDir(UV,neta,lo,z_tmp,z_tmp,z_t_tmp,z_t_tmp,p);
};

CImg<double> StructureFunctionPthLongAbs_crossDir(const CImg<double> &UV, int neta, int lo,double p){
  CImgList <double> z_tmp(lo-neta+1,UV.width(),UV.height());for (int k=0;k<=lo-neta;k++){z_tmp[k].fill(1.);}
  CImgList <double> z_t_tmp(lo-neta+1,UV.width(),UV.height());for (int k=0;k<=lo-neta;k++){z_t_tmp[k].fill(0.);}
  return StructureFunctionPthAbs_crossDir(UV,neta,lo,z_tmp,z_tmp,z_t_tmp,z_t_tmp,p);
};

/**
 *  LeastSquareFit
 */
CImg<double> LeastSquareFit(const CImg<double> &data,
                            double &slope,
                            double &origin){

  //-1e ligne contient valeurs x
  //-2e ligne contient y
  double xx, xy, x, y;
  int N = data.width();
  CImg<double> error;
  
  xx = data.get_line(0).sqr().sum();
  xy = (data.get_line(0).mul(data.get_line(1))).sum();
  x = data.get_line(0).sum();
  y = data.get_line(1).sum();
  
  slope = (N*xy - x*y)/(N*xx - x*x);
  origin = (xx*y - x*xy)/(N*xx - x*x);
  
  error.assign(N);
  for (int k=0; k<N; k++) {
    error(k) = slope*data(k,0) + origin - data(k,1);
  }
  return error;
};

/**
 *  StructureFunctionWidth
 */
CImg<double> StructureFunctionWidth(const CImg<double> &In,
                                    double order,
                                    int incMax){

  CImg<double> result(In.width()-1,1,1,1, 0.);
  int kdef = In.width()-1, kbound;
  
  //-check incMax if set by user
  if (incMax){
    if (incMax>kdef){
      cout << "/!\\StructureFunctionWidth(): Requested max increment (" << incMax << ") too high, using " << kdef << " instead."<< endl;
      kbound = kdef;
    }
    else { kbound = incMax; }
  }
  //-else default value
  else { kbound = kdef; }
  
  //-for each increment length
  for (int k=1; k<=kbound; k++) {
    //-for each line of In
    for (int q=0; q<In.height(); q++) {
      //-for each point
      for (int p=k; p<In.width(); p++) {
        result(k-1) += pow(abs(In(p,q)-In(p-k,q)),order);
      }
    }
    result(k-1)/=(In.height()*(kbound-k+1));
  }

  return result;
};

/**
 *  StructureFunctionHeight
 */
CImg<double> StructureFunctionHeight(const CImg<double> &In,
                                     double order,
                                     int incMax){
  
  CImg<double> result(In.height()-1,1,1,1, 0.);
  int kdef = In.height()-1, kbound;

  //-check incMax if set by user
  if (incMax){
    if (incMax>kdef){
      cout << "/!\\StructureFunctionHeight(): Requested max increment (" << incMax << ") too high, using " << kdef << " instead."<< endl;
      kbound = kdef;
    }
    else { kbound = incMax; }
  }
  //-else use default value
  else { kbound = kdef; }
  
  //-for each increment length
  for (int k=1; k<=kbound; k++) {
    //-for each column of In
    for (int p=0; p<In.width(); p++) {
      //-for each point
      for (int q=k; q<In.height(); q++) {
        result(k-1) += pow(abs(In(p,q)-In(p,q-k)),order);
      }
    }
    result(k-1)/=(In.width()*(kbound-k+1));
  }
  return result;
};

/**
 *  StuctureFunctionFullUV
 */
CImg<double> StructureFunctionFullUV(const CImg<double> &UV,
                                     double order,
                                     bool ux,
                                     bool uy,
                                     bool vx,
                                     bool vy,
                                     int incMax){
  CImg<double> SFtemp;
  int kdefx = UV.width() - 1, kdefy = UV.height() - 1, kdef, kbound, nSF=0;
  
  kdef = min(kdefx, kdefy);
  
  //-check incMax if set by user
  //--------------------------
  if(incMax){
    //-if only horizontal direction is concerned
    if ((ux||vx)&&!(uy||vy)&&(incMax>kdefx)){
      cout << "/!\\ Requested horizontal max increment (" << incMax << ") too high, corrected to " << kdefx << "."<< endl;
      kbound = kdefx;
    }
    //-if only vertical direction is concerned
    else if ((uy||vy)&&!(ux||vx)&&(incMax>kdefy)){
      cout << "/!\\ Requested vertical max increment (" << incMax << ") too high, corrected to " << kdefy << "."<< endl;
      kbound = kdefy;
    }
    //-if both directions are concerned
    else if ((ux||vx)&&(uy||vy)&&(incMax>kdef)){
      cout << "/!\\ Requested max horizontal & vertical increment (" << incMax << ") too high, corrected to " << kdef << "."<< endl;
      kbound = kdef;
    }
    //-nothing bad happened, we can use user's value
    else { kbound = incMax; }
  }
  //-else use no default value
  //---------------------------
  else{ 
    if ((ux||vx)&&!(uy||vy)) { kbound = kdefx; }
    else if ((uy||vy)&&!(ux||vx)) { kbound = kdefy; }    
    else if ((ux||vx)&&(uy||vy)) { kbound = kdef; }         
  }
  
  SFtemp.assign(kbound,1,1,1, 0.);
  if (ux) { SFtemp += StructureFunctionWidth(UV.get_shared_plane(0),order,kbound); nSF++;}
  if (uy) { SFtemp += StructureFunctionHeight(UV.get_shared_plane(0),order,kbound); nSF++;}
  if (vx) { SFtemp += StructureFunctionWidth(UV.get_shared_plane(1),order,kbound); nSF++;}
  if (vy) { SFtemp += StructureFunctionHeight(UV.get_shared_plane(1),order,kbound); nSF++;}
  if(nSF>1){ SFtemp/=nSF;}
  
  return SFtemp;
};